<template>
  <v-container grid-list-md>
    <v-layout row wrap>
      <v-flex xs4>
        <v-card>
          <v-card-text class="px-0">
            <h3>Request by disease name</h3>
            <v-form
                    class="pa-3"
                    ref="form"
                    lazy-validation>
              <v-text-field
                      label="Disease name"
                      v-model="drugName"
                      required></v-text-field>
              <div class="text-xs-center">
                <v-btn
                        :disabled="loading"
                        @click="sendRequestByDrugName()"
                        color="warning">
                  <span v-if="!loading">Send request</span>
                  <span v-else>Loading</span>
                </v-btn>
              </div>
            </v-form>
          </v-card-text>
        </v-card>
        <v-card class="mt-3">
          <v-card-text class="px-0">
            <h3>Custom request</h3>
            <v-form
                    class="pa-3"
                    ref="form">

              <SpecificField v-for="input in inputs"
                             v-if="!input.hide"
                             v-on:addField="addItem()"
                             v-on:removeField="removeItem($event)"
                             :ref="'input_'+input.id"
                             :type="input.type"
                             :id="input.id">
              </SpecificField>

              <div class="text-xs-center">
                <v-btn
                        color="primary"
                        dark
                        @click.stop="openPreviewRequestDialog()">
                  <v-icon>visibility</v-icon>
                </v-btn>
                <v-btn
                        :disabled="loading"
                        @click="sendRequestCustomizeFields()"
                        color="warning">
                  <span v-if="!loading">Send</span>
                  <span v-else>Loading</span>
                </v-btn>
                <v-btn
                        @click="resetCustomizeFields()"
                        color="error">
                  <v-icon>delete</v-icon>
                </v-btn>
              </div>
            </v-form>
          </v-card-text>
        </v-card>
        <v-card class="mt-3">
          <v-card-text class="px-0">
            <h3>Source power</h3>
            <v-form
                    class="pa-3">
              <v-slider
                      min="0"
                      max="10"
                      step="1"
                      ticks="always"
                      :thumb-size="24"
                      thumb-color="#F57F17"
                      thumb-label="always"
                      tick-size="3"
                      v-model="powerOrpha"
                      label="Orpha">
              </v-slider>
              <v-slider
                      min="0"
                      max="10"
                      step="1"
                      ticks="always"
                      :thumb-size="24"
                      thumb-color="#F57F17"
                      thumb-label="always"
                      tick-size="3"
                      v-model="powerOmim"
                      label="Omim">
              </v-slider>
              <v-slider
                      min="0"
                      max="10"
                      step="1"
                      ticks="always"
                      thumb-color="#F57F17"
                      :thumb-size="24"
                      thumb-label="always"
                      tick-size="3"
                      v-model="powerSider"
                      label="Sider ">
              </v-slider>
              <v-slider
                      min="0"
                      max="10"
                      step="1"
                      ticks="always"
                      thumb-color="#F57F17"
                      :thumb-size="24"
                      thumb-label="always"
                      tick-size="3"
                      v-model="powerDrug"
                      label="Drug">
              </v-slider>
            </v-form>
          </v-card-text>
        </v-card>
      </v-flex>
      <v-flex xs8>
        <v-card>
          <div v-if="loading" class="text-sm-center">
            <v-layout py-5>
              <v-flex xs-5></v-flex>
              <v-flex>
                <div class="breeding-rhombus-spinner"> <div class="rhombus child-1"></div> <div class="rhombus child-2"></div> <div class="rhombus child-3"></div> <div class="rhombus child-4"></div> <div class="rhombus child-5"></div> <div class="rhombus child-6"></div> <div class="rhombus child-7"></div> <div class="rhombus child-8"></div> <div class="rhombus big"></div> </div>
              </v-flex>
            </v-layout>
          </div>
          <v-card-text class="px-0" v-if="!loading">
            <h2><span v-if="items.length == 0">No results</span><span v-else>{{items.length}} results found</span></h2>
            <v-treeview
                    :open-on-click="true"
                    :items="items">
              <template slot="prepend" slot-scope="{ item }">
                <v-tooltip bottom v-if="item.source.includes('orpha')">
                  <template v-slot:activator="{ on }">
                    <v-icon small color="#757575" dark v-on="on">storage</v-icon>
                  </template>
                  <span>Orpha</span>
                </v-tooltip>
                <v-tooltip bottom v-if="item.source.includes('omim')">
                  <template v-slot:activator="{ on }">
                    <v-icon small color="#616161" dark v-on="on">sd_storage</v-icon>
                  </template>
                  <span>Omim</span>
                </v-tooltip>
                <v-tooltip bottom v-if="item.source.includes('sider')">
                  <template v-slot:activator="{ on }">
                    <v-icon small color="#424242" dark v-on="on">data_usage</v-icon>
                  </template>
                  <span>Sider</span>
                </v-tooltip>
                <v-tooltip bottom v-if="item.source.includes('drug')">
                  <template v-slot:activator="{ on }">
                    <v-icon small color="#212121" dark v-on="on">dvr</v-icon>
                  </template>
                  <span>Drugbank</span>
                </v-tooltip>
              </template>
            </v-treeview>
          </v-card-text>
        </v-card>
      </v-flex>
    </v-layout>
    <v-dialog
            v-model="previewRequestDialog"
            max-width="290">
      <v-card>
        <v-card-title class="headline amber lighten-1">Request preview</v-card-title>
        <v-card-text>
          <span class="font-weight-bold" v-html="previewRequestDialogText"></span>
        </v-card-text>
        <v-card-actions>
          <v-btn
                  color="amber darken-1"
                  flat="flat"
                  @click="previewRequestDialog = false">
            Ok
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog
            v-model="popupDialog"
            max-width="290">
      <v-card>
        <v-card-title class="headline amber lighten-1">Can't send request</v-card-title>
        <v-card-text>
          <span v-html="popupDialogText"></span>
        </v-card-text>
        <v-card-actions>
          <v-btn
                  color="amber darken-1"
                  flat="flat"
                  @click="popupDialog = false">
            Ok
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>
<script>
import axios from "axios";
import SpecificField from './SpecificField'
  export default {
    methods: {
      openPreviewRequestDialog(){
        this.previewRequestDialogText = '';
        let element;
        for( var i = 0; i < this.inputs.length; i++){
          if(!this.inputs[i].hide){
            element = this.$refs['input_'+i][0];
            if(element.inputValueAllowed) {
              if(element.type){
                this.previewRequestDialogText += '<br/><span style="color: #795548;">' + element.typeValue + '</span> ';
              }
              this.previewRequestDialogText += '<span style="color: #E65100;">' + element.fieldValue + '</span> = <span style="color: #3F51B5;">' + element.inputValue + '</span>';
            }
          }
        }
        if(this.previewRequestDialogText == '') {
          this.previewRequestDialogText = '<span class="font-weight-light">Request is empty</span>';
        }
        this.previewRequestDialog = true;
      },
      sendRequestByDrugName (){
        if(this.drugName == '') {
          this.drugName = 'Abetalipoproteinemia';
        }
        if(this.drugName == '') {
          this.popupDialogText = 'Can\'t perform request without drug name.';
          this.popupDialog = true;
        }else {
          this.loading = true;
          axios
                  .get('http://localhost:8888/search/atom/disease/' + this.drugName, {crossdomain: true})
                  .then(response => this.displayRequest(response))
                  .catch(error => console.log(error))
                  .then(response => (this.loading = false));
        }
      },
      displayRequest(response){
        let omim = response.data.data.Omim;
        let orpha = response.data.data.Orpha;
        let sider = response.data.data.Sider;
        let diseases = {};
        let elem;
        let diseaseName;
        let children;
        let text;
        let clinicalSigns;
        let synonyms;
        let drugFields = ['description','indication','toxicity'];
        let drugs;
        // Display Orpha
        for(var k in orpha){
          if(orpha.hasOwnProperty(k)) {
            if(Array.isArray(orpha[k])){
              for(var k2 in orpha[k]) {
                if (orpha[k].hasOwnProperty(k2)) {
                  this.orphaRun(diseases, orpha[k][k2],drugFields)
                }
              }
            }else {
              this.orphaRun(diseases, orpha[k],drugFields)
            }
          }
        }
        let omimFields = {Description:"description",Inheritance:"inheritance",Pathogenesis:"pathogenesis", Symptoms:"symptoms"}
        for(var k in omim){
          if(omim.hasOwnProperty(k)) {
            if(Array.isArray(omim[k])){
              for(var k2 in omim[k]) {
                if (omim[k].hasOwnProperty(k2)) {
                  if(Array.isArray(omim[k])){
                    for(var k3 in omim[k][k2]) {
                      if (omim[k][k2].hasOwnProperty(k3)) {
                        this.omimDiseaseRun(omim[k][k2][k3], diseases, omimFields, orpha[k3]);
                      }
                    }
                  }else {
                    this.omimDiseaseRun(omim[k][k2], diseases, omimFields, orpha[k2]);
                  }
                }
              }
            }else {
              this.omimDiseaseRun(omim[k], diseases, omimFields, orpha[k]);
            }
          }
        }
        if(sider) {
          sider.forEach(function (element) {
            if(element) {
              element.forEach(function (element2) {
                if (element2) {
                  if (Array.isArray(element2)) {
                    element2.forEach(function (sidEl) {
                      for (var k in diseases) {
                        if (diseases.hasOwnProperty(k)) {
                          diseases[k].CUI.forEach(function (cui) {
                            if (cui == sidEl.Cui) {
                              diseases[k].children["Side effects"][sidEl.Label] = {};
                              diseases[k].children["Side effects"][sidEl.Label].name = sidEl.Label;
                              diseases[k].children["Side effects"][sidEl.Label].source = 'sider';
                            }
                          });
                        }
                      }
                    })
                  } else {
                    for (var k in diseases) {
                      if (diseases.hasOwnProperty(k)) {
                        diseases[k].CUI.forEach(function (cui) {
                          if (cui == element2.Cui) {
                            diseases[k].children["Side effects"][element2.Label] = {};
                            diseases[k].children["Side effects"][element2.Label].name = element2.Label;
                            diseases[k].children["Side effects"][element2.Label].source = 'sider';
                          }
                        });
                      }
                    }
                  }
                }
              });
            }
          });
        }

        let fieldsCanBeRemoved = ["Drugs","Side effects", "Description","Inheritance","Pathogenesis", "Clinical signs", "Synonyms", "Symptoms"]
        for (var k in diseases) {
          if (diseases.hasOwnProperty(k)) {
            fieldsCanBeRemoved.forEach(function (fieldRemove) {
              let remove = true;
              if(diseases[k].children) {
                for (var i in diseases[k].children[fieldRemove]) {
                  if (diseases[k].children[fieldRemove].hasOwnProperty(i)) {
                    remove = false;
                  }
                }
                if (remove) {
                  delete diseases[k].children[fieldRemove]
                }
              }
            })
          }
        }

        //console.log(diseases);
        this.items = this.objectToArray(diseases,'');
      },
      orphaRun(diseases, orpha, drugFields){
        let elem;
        let diseaseName;
        let synonyms;
        let drugs;
        let clinicalSigns;
        let children = {};
        children["Side effects"] = {};
        children["Description"] = {};
        children["Inheritance"] = {};
        children["Pathogenesis"] = {};
        children["Clinical signs"] = {};
        children["Synonyms"] = {};
        children["Symptoms"] = {};
        children["Drugs"] = {};
        elem = orpha;
        diseaseName = elem.Name.text;
        diseases[diseaseName] = {};
        diseases[diseaseName].CUI = [];
        diseases[diseaseName].MEDDRA = [];
        diseases[diseaseName].OMIM = [];
        diseases[diseaseName].name = diseaseName;
        diseases[diseaseName].source = 'orpha';
        // External links
        if (elem.ExternalReferenceList) {
          if (elem.ExternalReferenceList.count > 0) {
            if (elem.ExternalReferenceList.count == 1) {
              if(elem.ExternalReferenceList.ExternalReference.Source == 'MEDDRA'){
                diseases[diseaseName].MEDDRA.push(elem.ExternalReferenceList.ExternalReference.Reference);
              }
              if(elem.ExternalReferenceList.ExternalReference.Source == 'UMLS') {
                diseases[diseaseName].CUI.push(elem.ExternalReferenceList.ExternalReference.Reference);
              }
              if(elem.ExternalReferenceList.ExternalReference.Source == 'OMIM') {
                diseases[diseaseName].OMIM.push(elem.ExternalReferenceList.ExternalReference.Reference);
              }
            } else {
              for (var link in elem.ExternalReferenceList.ExternalReference) {
                if (elem.ExternalReferenceList.ExternalReference.hasOwnProperty(link)) {
                  if (elem.ExternalReferenceList.ExternalReference[link].Source == 'MEDDRA') {
                    diseases[diseaseName].MEDDRA.push(elem.ExternalReferenceList.ExternalReference[link].Reference);
                  }
                  if (elem.ExternalReferenceList.ExternalReference[link].Source == 'UMLS') {
                    diseases[diseaseName].CUI.push(elem.ExternalReferenceList.ExternalReference[link].Reference);
                  }
                  if (elem.ExternalReferenceList.ExternalReference[link].Source == 'OMIM') {
                    diseases[diseaseName].OMIM.push(elem.ExternalReferenceList.ExternalReference[link].Reference);
                  }
                }
              }
            }
            diseases[diseaseName].children = children;
          }
        }
        // Drugs
        if (elem.drugs) {
          drugs = children["Drugs"];
          if(elem.drugs.indication) {
            elem.drugs.indication.forEach(function (drug) {
              text = drug.name;
              drugs[text] = {};
              drugs[text].name = text;
              drugs[text].source = 'drug';
              drugs[text].children = {};
              drugFields.forEach(function (drugField) {
                if(drug[drugField] != '') {
                  drugs[text].children[drugField] = {};
                  drugs[text].children[drugField][drug[drugField]] = {};
                  drugs[text].children[drugField][drug[drugField]].name = drug[drugField];
                  drugs[text].children[drugField][drug[drugField]].source = "drug";
                }
              });
            });
          }
        }
        let text;
        // Clinical signs
        if (elem.clinical_signs) {
          clinicalSigns = children["Clinical signs"];
          elem.clinical_signs.forEach(function (sign) {
            text = sign.clinicalSign.Name.text;
            clinicalSigns[text] = {};
            clinicalSigns[text].name = text;
            clinicalSigns[text].source = 'orpha';
          });
        }
        // Synonyms
        if (elem.SynonymList) {
          if (elem.SynonymList.count > 0) {
            synonyms = children["Synonyms"];
            if (elem.SynonymList.count == 1) {
              text = elem.SynonymList.Synonym.text;
              synonyms[text] = {};
              synonyms[text].name = text;
              synonyms[text].source = 'orpha';
            } else {
              for (var synonym in elem.SynonymList.Synonym) {
                if (elem.SynonymList.Synonym.hasOwnProperty(synonym)) {
                  text = elem.SynonymList.Synonym[synonym].text;
                  synonyms[text] = {};
                  synonyms[text].name = text;
                  synonyms[text].source = 'orpha';
                }
              }
            }
            //console.log(elem);
            diseases[diseaseName].children = children;
          }
        }
      },
      omimDiseaseRun(omim, diseases, omimFields, orpha){
        let children;
        let omimDisease = null;
        let diseaseName;
        let elem;
        for (var i in diseases) {
          if (diseases.hasOwnProperty(i)) {
            diseases[i].OMIM.forEach(function (om) {
              if (om+"" == omim.id) {
                omimDisease = diseases[i];
                omimDisease.source += 'omim';
              }
            });
          }
        }
        if(!omimDisease){
          children = {};
          children["Side effects"] = {};
          children["Description"] = {};
          children["Inheritance"] = {};
          children["Pathogenesis"] = {};
          children["Symptoms"] = {};
          children["Clinical signs"] = {};
          children["Synonyms"] = {};
          children["Drugs"] = {};
          elem = orpha;
          diseaseName = omim.name;
          diseases[diseaseName] = {};
          diseases[diseaseName].CUI = [];
          diseases[diseaseName].MEDDRA = [];
          diseases[diseaseName].OMIM = [omim.id];
          diseases[diseaseName].name = diseaseName;
          diseases[diseaseName].source = 'omim';
          diseases[diseaseName].children = children;
          omimDisease = diseases[diseaseName];
        }
        for(var f in omimFields){
          if (omimFields.hasOwnProperty(f)) {
            if(omim[omimFields[f]] != '') {
              omimDisease.children[f][omim[omimFields[f]]] = {};
              omimDisease.children[f][omim[omimFields[f]]].name = omim[omimFields[f]];
              omimDisease.children[f][omim[omimFields[f]]].source = "omim";
            }
          }
        }
      },
      objectToArray(object, id){
        let number = 0;
        let res = [];
        for(var k in object) {
          if (object.hasOwnProperty(k)) {
            let obj = {};
            let children;
            if(object[k].name) {
              obj.name = object[k].name;
              obj.source = object[k].source;
              obj.id = id + (number++);
              obj.children = [];
              for (var i in object[k].children) {
                if (object[k].children.hasOwnProperty(i)) {
                  children = {};
                  children.name = i;
                  children.source = '';
                  children.id = id + (number++);
                  children.children = this.objectToArray(object[k].children[i], id + (number++));
                  obj.children.push(children);
                }
              }
              res.push(obj);
            }
          }
        }
        let parent = this;
        res.sort(function(a, b) {
          if(a.source && b.source){
            return parent.powerCalcul(a.source) < parent.powerCalcul(b.source);
          }
          return false;
        });
        return res;
      },
      powerCalcul(source){
        let power = 0;
        let parent = this;
        let sourcePower;
        let sources = ['omim','orpha','sider','drug'];
        sources.forEach(function (sourcesItem) {
          if(source.includes(sourcesItem)){
            switch (sourcesItem) {
              case 'omim':
                sourcePower = parent.powerOmim;
                break;
              case 'orpha':
                sourcePower = parent.powerOrpha;
                break;
              case 'sider':
                sourcePower = parent.powerSider;
                break;
              case 'drug':
                sourcePower = parent.powerDrug;
                break;
            }
            power += sourcePower;
          }
        });
        return power;
      },
      sendRequestCustomizeFields (){
        let element;
        let perform = false;
        let error = '';
        let requestString = '';
        for( var i = 0; i < this.inputs.length; i++){
          if(!this.inputs[i].hide && error == ''){
            element = this.$refs['input_'+i][0];
            if(element.inputValueAllowed) {
              perform = true;
              if(element.type){
                requestString += ' '+element.typeValue + ' ';
              }
              requestString += element.fieldValue+' = '+element.inputValue;
              if(element.inputValue == ''){
                error = 'Field "'+element.fieldValue+'" is empty';
              }
            }
          }
        }
        if(!perform) {
          error = 'Can\'t perform request without any fields.';
        }

        if(error == ''){
          let obj = this.recursive(requestString);
          this.loading = true;
          axios
                  .post('http://localhost:8888/search/collection/diseases', JSON.stringify(obj), {crossdomain: true})
                  .then(response => this.displayRequest(response))
                  .catch(error => console.log(error))
                  .then(response => (this.loading = false));
        }else{
          this.popupDialogText = error;
          this.popupDialog = true;
        }

      },
      recursive(string){
        let obj = {};
        let rigthPart; let leftPart;
        let indice = string.indexOf("OR");
        if(indice != -1){
          leftPart = string.substr(0, indice);
          rigthPart = string.substr(indice+2);
          obj.or = [];
          obj.or.push(this.recursive(leftPart));
          obj.or.push(this.recursive(rigthPart));
        }else {
          indice = string.indexOf("AND");
          if(indice != -1){
            leftPart = string.substr(0, indice);
            rigthPart = string.substr(indice+3);
            obj.and = [];
            obj.and.push(this.recursive(leftPart));
            obj.and.push(this.recursive(rigthPart));
          }else {
            let element = string.split("=");
            obj[element[0].split(' ').join('').split('/').join('')] = element[1].substr(1);
          }
        }
        return obj;
      },
      resetCustomizeFields (){
        for( var i = 0; i < this.inputs.length; i++){
          this.inputs[i].hide = true;
        }
        this.inputs.push({
          id: this.inputId++,
          hide: false,
          type: false
        });
      },
      removeItem(event) {
        let firstElement = -1;
        for( var i = 0; i < this.inputs.length; i++){
          if ( this.inputs[i].id === event) {
            this.inputs[i].hide = true;
          }else if(this.inputs[i].hide == false && firstElement == -1){
            firstElement = i;
          }
        }
        this.inputs[firstElement].type = false;
        this.inputs.push({hide:true, id:-1, type:true});
        this.inputs.pop();
      },
      addItem() {
        this.inputs.push({
          id: this.inputId++,
          hide: false,
          type: true
        });
      }
    },
    components: {
      SpecificField
    },
    data: () => ({
      loading: false,
      previewRequestDialogText: '',
      previewRequestDialog: false,
      popupDialogText: '',
      popupDialog: false,
      info : '',
      drugName: '',
      on : false,
      inputId: 1,
      inputs : [{hide:false, id:0, type:false}],
      items: [],
      powerDrug : 5,
      powerOrpha : 5,
      powerOmim : 5,
      powerSider : 5
    })
  }
</script>
<style>
  h2{
    padding-left: 1em;
    color: #FF9100;
  }
  h3{
    padding-left: 1em;
    color: #FF6D00;
  }

  .v-treeview-node__content, .v-treeview-node__label {
    flex-shrink: 1;
    padding-right: 5px;
  }
  .v-treeview-node__root {
    height: auto;
  }

  /* Node parents*/
  .v-treeview-node > .v-treeview-node__root > .v-treeview-node__toggle+.v-treeview-node__content {
    font-weight: bold;
  }
  /*Level 1*/
  .v-treeview > .v-treeview-node > .v-treeview-node__root > .v-treeview-node__toggle {
    color: #FF6D00;
  }
  /*Level 2*/
  .v-treeview > .v-treeview-node > .v-treeview-node__children > .v-treeview-node > .v-treeview-node__root > .v-treeview-node__toggle {
    color: #FF9100;
  }
  /*Level 3*/
  .v-treeview > .v-treeview-node > .v-treeview-node__children > .v-treeview-node > .v-treeview-node__children > .v-treeview-node > .v-treeview-node__root > .v-treeview-node__toggle {
    color: #FFAB00;
  }

  .breeding-rhombus-spinner {
    height: 65px;
    width: 65px;
    position: relative;
    transform: rotate(45deg);
  }
  .breeding-rhombus-spinner, .breeding-rhombus-spinner * {
    box-sizing: border-box;
  }
  .breeding-rhombus-spinner .rhombus {
    height: calc(65px / 7.5);
    width: calc(65px / 7.5);
    animation-duration: 2000ms;
    top: calc(65px / 2.3077);
    left: calc(65px / 2.3077);
    background-color: #FFA726;
    position: absolute;
    animation-iteration-count: infinite;
  }
  .breeding-rhombus-spinner .rhombus:nth-child(2n+0) {
    margin-right: 0;
  }
  .breeding-rhombus-spinner .rhombus.child-1 {
    animation-name: breeding-rhombus-spinner-animation-child-1;
    animation-delay: calc(100ms * 1);
  }
  .breeding-rhombus-spinner .rhombus.child-2 {
    animation-name: breeding-rhombus-spinner-animation-child-2;
    animation-delay: calc(100ms * 2);
  }
  .breeding-rhombus-spinner .rhombus.child-3 {
    animation-name: breeding-rhombus-spinner-animation-child-3;
    animation-delay: calc(100ms * 3);
  }
  .breeding-rhombus-spinner .rhombus.child-4 {
    animation-name: breeding-rhombus-spinner-animation-child-4;
    animation-delay: calc(100ms * 4);
  }
  .breeding-rhombus-spinner .rhombus.child-5 {
    animation-name: breeding-rhombus-spinner-animation-child-5;
    animation-delay: calc(100ms * 5);
  }
  .breeding-rhombus-spinner .rhombus.child-6 {
    animation-name: breeding-rhombus-spinner-animation-child-6;
    animation-delay: calc(100ms * 6);
  }
  .breeding-rhombus-spinner .rhombus.child-7 {
    animation-name: breeding-rhombus-spinner-animation-child-7;
    animation-delay: calc(100ms * 7);
  }
  .breeding-rhombus-spinner .rhombus.child-8 {
    animation-name: breeding-rhombus-spinner-animation-child-8;
    animation-delay: calc(100ms * 8);
  }
  .breeding-rhombus-spinner .rhombus.big {
    height: calc(65px / 3);
    width: calc(65px / 3);
    animation-duration: 2000ms;
    top: calc(65px / 3);
    left: calc(65px / 3);
    background-color: #FB8C00;
    animation: breeding-rhombus-spinner-animation-child-big 2s infinite;
    animation-delay: 0.5s;
  }
  @keyframes breeding-rhombus-spinner-animation-child-1 {
    50% {
      transform: translate(-325%, -325%);
    }
  }
  @keyframes breeding-rhombus-spinner-animation-child-2 {
    50% {
      transform: translate(0, -325%);
    }
  }
  @keyframes breeding-rhombus-spinner-animation-child-3 {
    50% {
      transform: translate(325%, -325%);
    }
  }
  @keyframes breeding-rhombus-spinner-animation-child-4 {
    50% {
      transform: translate(325%, 0);
    }
  }
  @keyframes breeding-rhombus-spinner-animation-child-5 {
    50% {
      transform: translate(325%, 325%);
    }
  }
  @keyframes breeding-rhombus-spinner-animation-child-6 {
    50% {
      transform: translate(0, 325%);
    }
  }
  @keyframes breeding-rhombus-spinner-animation-child-7 {
    50% {
      transform: translate(-325%, 325%);
    }
  }
  @keyframes breeding-rhombus-spinner-animation-child-8 {
    50% {
      transform: translate(-325%, 0);
    }
  }
  @keyframes breeding-rhombus-spinner-animation-child-big {
    50% {
      transform: scale(0.5);
    }
  }

  div.loader{
    text-align: center;
  }
  div.loader > span{
    display: inline;
  }
</style>
